00aed45aef2cb9c41157bdff096b005172cd9190
[m6w6/libmemcached] / bootstrap.sh
1 #!/bin/bash
2 #
3 # Copyright (C) 2012 Brian Aker
4 # All rights reserved.
5 #
6 # Redistribution and use in source and binary forms, with or without
7 # modification, are permitted provided that the following conditions are
8 # met:
9 #
10 # * Redistributions of source code must retain the above copyright
11 # notice, this list of conditions and the following disclaimer.
12 #
13 # * Redistributions in binary form must reproduce the above
14 # copyright notice, this list of conditions and the following disclaimer
15 # in the documentation and/or other materials provided with the
16 # distribution.
17 #
18 # * The names of its contributors may not be used to endorse or
19 # promote products derived from this software without specific prior
20 # written permission.
21 #
22 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
23 # "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
24 # LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
25 # A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
26 # OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
27 # SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
28 # LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
29 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
30 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
31 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
32 # OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
33
34
35 # Environment Variables that will influence the build:
36 # AUTOMAKE
37 # AUTORECONF
38 # LIBTOOLIZE
39 # MAKE
40 # PREFIX
41 # TESTS_ENVIRONMENT
42 # VERBOSE
43 # WARNINGS
44 #
45
46 command_not_found_handle ()
47 {
48 echo "Command not found: '$@'"
49 exit 127
50 }
51
52 die ()
53 {
54 echo "$BASH_SOURCE:$BASH_LINENO: $@" >&2
55 exit 1;
56 }
57
58 function nassert ()
59 {
60 local param_name=\$"$1"
61 local param_value=`eval "expr \"$param_name\" "`
62
63 if [ -n "$param_value" ]; then
64 echo "$bash_source:$bash_lineno: assert($param_name) had value of "$param_value"" >&2
65 exit 1
66 fi
67 }
68
69 function assert ()
70 {
71 local param_name=\$"$1"
72 local param_value=`eval "expr \"$param_name\" "`
73
74 if [ -z "$param_value" ]; then
75 echo "$bash_source:$bash_lineno: assert($param_name)" >&2
76 exit 1
77 fi
78 }
79
80 assert_file ()
81 {
82 if [ ! -f "$1" ]; then
83 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
84 exit 1;
85 fi
86 }
87
88 assert_no_file ()
89 {
90 if [ -f "$1" ]; then
91 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) file exists: $2" >&2
92 exit 1;
93 fi
94 }
95
96 assert_exec_file ()
97 {
98 if [ ! -f "$1" ]; then
99 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) does not exist: $2" >&2
100 exit 1;
101 fi
102
103 if [ ! -x "$1" ]; then
104 echo "$BASH_SOURCE:$BASH_LINENO: assert($1) exists but is not executable: $2" >&2
105 exit 1;
106 fi
107 }
108
109 command_exists ()
110 {
111 type "$1" &> /dev/null ;
112 }
113
114 rebuild_host_os ()
115 {
116 HOST_OS="${UNAME_MACHINE_ARCH}-${VENDOR}-${VENDOR_DISTRIBUTION}-${VENDOR_RELEASE}-${UNAME_KERNEL}-${UNAME_KERNEL_RELEASE}"
117 if [ -z "$1" ]; then
118 if $VERBOSE; then
119 echo "HOST_OS=$HOST_OS"
120 fi
121 fi
122 }
123
124 # Valid values are: darwin,fedora,rhel,ubuntu
125 set_VENDOR_DISTRIBUTION ()
126 {
127 local dist=`echo "$1" | tr '[A-Z]' '[a-z]'`
128 case "$dist" in
129 darwin)
130 VENDOR_DISTRIBUTION='darwin'
131 ;;
132 fedora)
133 VENDOR_DISTRIBUTION='fedora'
134 ;;
135 rhel)
136 VENDOR_DISTRIBUTION='rhel'
137 ;;
138 ubuntu)
139 VENDOR_DISTRIBUTION='ubuntu'
140 ;;
141 opensuse)
142 VENDOR_DISTRIBUTION='opensuse'
143 ;;
144 *)
145 die "attempt to set an invalid VENDOR_DISTRIBUTION=$dist"
146 ;;
147 esac
148 }
149
150 set_VENDOR_RELEASE ()
151 {
152 local release=`echo "$1" | tr '[A-Z]' '[a-z]'`
153 case "$VENDOR_DISTRIBUTION" in
154 darwin)
155 VENDOR_RELEASE='mountain'
156 ;;
157 fedora)
158 VENDOR_RELEASE="$release"
159 ;;
160 rhel)
161 VENDOR_RELEASE="$release"
162 ;;
163 ubuntu)
164 VENDOR_RELEASE="$release"
165 ;;
166 opensuse)
167 VENDOR_RELEASE="$release"
168 ;;
169 unknown)
170 die "attempt to set VENDOR_RELEASE without setting VENDOR_DISTRIBUTION"
171 ;;
172 *)
173 die "attempt to set with an invalid VENDOR_DISTRIBUTION=$VENDOR_DISTRIBUTION"
174 ;;
175 esac
176 }
177
178
179 # Valid values are: apple, redhat, centos, canonical
180 set_VENDOR ()
181 {
182 local vendor=`echo "$1" | tr '[A-Z]' '[a-z]'`
183
184 case $vendor in
185 apple)
186 VENDOR='apple'
187 ;;
188 redhat)
189 VENDOR='redhat'
190 ;;
191 centos)
192 VENDOR='centos'
193 ;;
194 canonical)
195 VENDOR='canonical'
196 ;;
197 suse)
198 VENDOR='suse'
199 ;;
200 *)
201 die "An attempt was made to set an invalid VENDOR=$_vendor"
202 ;;
203 esac
204
205 set_VENDOR_DISTRIBUTION $2
206 set_VENDOR_RELEASE $3
207 }
208
209 determine_target_platform ()
210 {
211 UNAME_MACHINE_ARCH=`(uname -m) 2>/dev/null` || UNAME_MACHINE_ARCH=unknown
212 UNAME_KERNEL=`(uname -s) 2>/dev/null` || UNAME_SYSTEM=unknown
213 UNAME_KERNEL_RELEASE=`(uname -r) 2>/dev/null` || UNAME_KERNEL_RELEASE=unknown
214
215 if [[ $(uname) == 'Darwin' ]]; then
216 set_VENDOR 'apple' 'darwin' 'mountain'
217 elif [[ -f '/etc/fedora-release' ]]; then
218 local fedora_version=`cat /etc/fedora-release | awk ' { print $3 } '`
219 set_VENDOR 'redhat' 'fedora' $fedora_version
220 if [[ "x$VENDOR_RELEASE" == 'x17' ]]; then
221 AUTORECONF_REBUILD_HOST=true
222 fi
223 elif [[ -f '/etc/centos-release' ]]; then
224 local centos_version=`cat /etc/centos-release | awk ' { print $7 } '`
225 set_VENDOR 'centos' 'rhel' $centos_version
226 elif [[ -f '/etc/SuSE-release' ]]; then
227 local suse_distribution=`head -1 /etc/SuSE-release | awk ' { print $1 } '`
228 local suse_version=`head -1 /etc/SuSE-release | awk ' { print $2 } '`
229 set_VENDOR 'suse' $suse_distribution $suse_version
230 elif [[ -f '/etc/redhat-release' ]]; then
231 local rhel_version=`cat /etc/redhat-release | awk ' { print $7 } '`
232 set_VENDOR 'redhat' 'rhel' $rhel_version
233 elif [[ -f '/etc/lsb-release' ]]; then
234 local debian_DISTRIB_ID=`cat /etc/lsb-release | grep DISTRIB_ID | awk -F= ' { print $2 } '`
235 local debian_version=`cat /etc/lsb-release | grep DISTRIB_CODENAME | awk -F= ' { print $2 } '`
236 set_VENDOR 'canonical' $debian_DISTRIB_ID $debian_version
237 if [[ "x$VENDOR_RELEASE" == 'xprecise' ]]; then
238 AUTORECONF_REBUILD_HOST=true
239 fi
240 fi
241
242 rebuild_host_os
243 }
244
245 run_configure ()
246 {
247 # We will run autoreconf if we are required
248 run_autoreconf_if_required
249
250 # We always begin at the root of our build
251 if [ ! popd ]; then
252 die "Programmer error, we entered run_configure with a stacked directory"
253 fi
254
255 local BUILD_DIR="$1"
256 if [[ -n "$BUILD_DIR" ]]; then
257 rm -r -f $BUILD_DIR
258 mkdir -p $BUILD_DIR
259 safe_pushd $BUILD_DIR
260 fi
261
262 # Arguments for configure
263 local CONFIGURE_ARG=
264
265 # Set ENV DEBUG in order to enable debugging
266 if $DEBUG; then
267 CONFIGURE_ARG='--enable-debug'
268 fi
269
270 # Set ENV ASSERT in order to enable assert
271 if [[ -n "$ASSERT" ]]; then
272 local ASSERT_ARG=
273 ASSERT_ARG='--enable-assert'
274 CONFIGURE_ARG="$ASSERT_ARG $CONFIGURE_ARG"
275 fi
276
277 # If we are executing on OSX use CLANG, otherwise only use it if we find it in the ENV
278 case $HOST_OS in
279 *-darwin-*)
280 CC=clang CXX=clang++ $top_srcdir/configure $CONFIGURE_ARG || die "Cannot execute CC=clang CXX=clang++ configure $CONFIGURE_ARG $PREFIX_ARG"
281 ;;
282 rhel-5*)
283 command_exists gcc44 || die "Could not locate gcc44"
284 CC=gcc44 CXX=gcc44 $top_srcdir/configure $CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute CC=gcc44 CXX=gcc44 configure $CONFIGURE_ARG $PREFIX_ARG"
285 ;;
286 *)
287 $top_srcdir/configure $CONFIGURE_ARG $PREFIX_ARG || die "Cannot execute configure $CONFIGURE_ARG $PREFIX_ARG"
288 ;;
289 esac
290
291 if [ ! -f 'Makefile' ]; then
292 die "Programmer error, configure was run but no Makefile existed afterward"
293 fi
294 }
295
296 setup_gdb_command () {
297 GDB_TMPFILE=$(mktemp /tmp/gdb.XXXXXXXXXX)
298 echo 'set logging overwrite on' > $GDB_TMPFILE
299 echo 'set logging on' >> $GDB_TMPFILE
300 echo 'set environment LIBTEST_IN_GDB=1' >> $GDB_TMPFILE
301 echo 'run' >> $GDB_TMPFILE
302 echo 'thread apply all bt' >> $GDB_TMPFILE
303 echo 'quit' >> $GDB_TMPFILE
304 GDB_COMMAND="gdb -f -batch -x $GDB_TMPFILE"
305 }
306
307 setup_valgrind_command () {
308 VALGRIND_PROGRAM=`type -p valgrind`
309 if [[ -n "$VALGRIND_PROGRAM" ]]; then
310 VALGRIND_COMMAND="$VALGRIND_PROGRAM --error-exitcode=1 --leak-check=yes --show-reachable=yes --track-fds=yes --malloc-fill=A5 --free-fill=DE"
311 fi
312 }
313
314 push_PREFIX_ARG ()
315 {
316 if [[ -n "$PREFIX_ARG" ]]; then
317 OLD_PREFIX_ARG=$PREFIX_ARG
318 PREFIX_ARG=
319 fi
320
321 if [[ -n "$1" ]]; then
322 PREFIX_ARG="--prefix=$1"
323 fi
324 }
325
326 pop_PREFIX_ARG ()
327 {
328 if [[ -n "$OLD_PREFIX_ARG" ]]; then
329 PREFIX_ARG=$OLD_TESTS_ENVIRONMENT
330 OLD_PREFIX_ARG=
331 else
332 PREFIX_ARG=
333 fi
334 }
335
336 push_TESTS_ENVIRONMENT ()
337 {
338 if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
339 die "OLD_TESTS_ENVIRONMENT was set on push, programmer error!"
340 fi
341
342 if [[ -n "$TESTS_ENVIRONMENT" ]]; then
343 OLD_TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT
344 TESTS_ENVIRONMENT=
345 fi
346 }
347
348 pop_TESTS_ENVIRONMENT ()
349 {
350 TESTS_ENVIRONMENT=
351 if [[ -n "$OLD_TESTS_ENVIRONMENT" ]]; then
352 TESTS_ENVIRONMENT=$OLD_TESTS_ENVIRONMENT
353 OLD_TESTS_ENVIRONMENT=
354 fi
355 }
356
357 function safe_pushd ()
358 {
359 pushd $1 &> /dev/null ;
360
361 if $VERBOSE -a test -n "$BUILD_DIR"; then
362 echo "BUILD_DIR=$BUILD_DIR"
363 fi
364 }
365
366 function safe_popd ()
367 {
368 local directory_to_delete=`pwd`
369 popd &> /dev/null ;
370 if [ $? -eq 0 ]; then
371 if [[ "$top_srcdir" == "$directory_to_delete" ]]; then
372 die "We almost deleted top_srcdir($top_srcdir), programmer error"
373 fi
374
375 rm -r -f "$directory_to_delete"
376 fi
377 }
378
379 function make_valgrind ()
380 {
381 if [[ "$VENDOR_DISTRIBUTION" == 'darwin' ]]; then
382 make_darwin_malloc
383 return
384 fi
385
386 # If the env VALGRIND_COMMAND is set then we assume it is valid
387 local valgrind_was_set=false
388 if [[ -z "$VALGRIND_COMMAND" ]]; then
389 setup_valgrind_command
390 if [[ -n "$VALGRIND_COMMAND" ]]; then
391 valgrind_was_set=true
392 fi
393 else
394 valgrind_was_set=true
395 fi
396
397 # If valgrind_was_set is set to no we bail
398 if ! $valgrind_was_set; then
399 echo 'valgrind was not present'
400 return 1
401 fi
402
403 # If we are required to run configure, do so now
404 run_configure_if_required
405
406 push_TESTS_ENVIRONMENT
407
408 # If we don't have a configure, then most likely we will be missing libtool
409 assert_file 'configure'
410 if [[ -f 'libtool' ]]; then
411 TESTS_ENVIRONMENT="./libtool --mode=execute $VALGRIND_COMMAND"
412 else
413 TESTS_ENVIRONMENT="$VALGRIND_COMMAND"
414 fi
415
416 make_target 'check' || return 1
417
418 pop_TESTS_ENVIRONMENT
419 }
420
421 function make_install_system ()
422 {
423 local INSTALL_LOCATION=$(mktemp -d /tmp/XXXXXXXXXX)
424 push_PREFIX_ARG $INSTALL_LOCATION
425
426 if [ ! -d $INSTALL_LOCATION ] ; then
427 die "ASSERT temp directory not found '$INSTALL_LOCATION'"
428 fi
429
430 run_configure #install_buid_dir
431
432 push_TESTS_ENVIRONMENT
433
434 make_target 'install'
435
436 make_target 'installcheck'
437
438 make_target 'uninstall'
439
440 pop_TESTS_ENVIRONMENT
441 pop_PREFIX_ARG
442
443 rm -r -f $INSTALL_LOCATION
444 make 'distclean'
445
446 if [ -f 'Makefile' ]; then
447 die "ASSERT Makefile should not exist"
448 fi
449
450 safe_popd
451 }
452
453 function make_darwin_malloc ()
454 {
455 run_configure_if_required
456
457 old_MallocGuardEdges=$MallocGuardEdges
458 MallocGuardEdges=1
459 old_MallocErrorAbort=$MallocErrorAbort
460 MallocErrorAbort=1
461 old_MallocScribble=$MallocScribble
462 MallocScribble=1
463
464 make_check
465
466 MallocGuardEdges=$old_MallocGuardEdges
467 MallocErrorAbort=$old_MallocErrorAbort
468 MallocScribble=$old_MallocScribble
469 }
470
471 function snapshot_check ()
472 {
473 if [ -n "$BOOTSTRAP_SNAPSHOT_CHECK" ]; then
474 assert_file "$BOOTSTRAP_SNAPSHOT_CHECK" 'snapshot check failed'
475 fi
476 }
477
478 # This will reset our environment, and make sure built files are available.
479 function make_for_snapshot ()
480 {
481 # Make sure it is clean
482 make_maintainer_clean
483
484 run_configure
485 make_target 'dist'
486 make_target 'distclean'
487
488 # We should have a configure, but no Makefile at the end of this exercise
489 assert_no_file 'Makefile'
490 assert_exec_file 'configure'
491
492 snapshot_check
493 }
494
495 # If we are locally testing, we should make sure the environment is setup correctly
496 function check_for_jenkins ()
497 {
498 if ! $jenkins_build_environment; then
499 echo "Not inside of jenkins"
500
501 if [ -f 'configure' ]; then
502 make_maintainer_clean
503 fi
504
505 if $BOOTSTRAP_SNAPSHOT; then
506 make_for_snapshot
507 fi
508 fi
509 }
510
511 function make_for_continuus_integration ()
512 {
513 # Setup the environment if we are local
514 check_for_jenkins
515
516 # No matter then evironment, we should not have a Makefile at this point
517 assert_no_file 'Makefile'
518
519 # Platforms which require bootstrap should have some setup done before we hit this stage.
520 # If we are building locally, skip this step, unless we are just testing locally.
521 if $BOOTSTRAP_SNAPSHOT; then
522 snapshot_check
523 else
524 # If we didn't require a snapshot, then we should not have a configure
525 assert_no_file 'configure'
526
527 run_autoreconf
528 fi
529
530 assert_no_file 'Makefile' 'Programmer error, Makefile existed where build state should have been clean'
531
532 case $HOST_OS in
533 *-fedora-*)
534 run_configure
535
536 assert_exec_file 'configure'
537 assert_file 'Makefile'
538
539 # make rpm includes "make distcheck"
540 if [[ -f rpm.am ]]; then
541 make_rpm
542 elif [[ -d rpm ]]; then
543 make_rpm
544 else
545 make_distcheck
546 fi
547
548 assert_exec_file 'configure'
549 assert_file 'Makefile'
550
551 make_install_system
552 ;;
553 *-precise-*)
554 run_configure
555
556 assert_exec_file 'configure'
557 assert_file 'Makefile'
558
559 make_distcheck
560
561 assert_exec_file 'configure'
562 assert_file 'Makefile'
563
564 make_valgrind
565
566 assert_exec_file 'configure'
567 assert_file 'Makefile'
568
569 make_install_system
570 ;;
571 *)
572 make_jenkins_default
573 ;;
574 esac
575
576 make_maintainer_clean
577
578 safe_popd
579 }
580
581 # The point to this test is to test bootstrap.sh itself
582 function self_test ()
583 {
584 # We start off with a clean env
585 make_maintainer_clean
586
587 eval "./bootstrap.sh jenkins" || die "failed 'jenkins'"
588 eval "./bootstrap.sh all" || die "failed 'all'"
589 eval "./bootstrap.sh gdb" || die "failed 'gdb'"
590 eval "./bootstrap.sh maintainer-clean" || die "failed 'maintainer-clean'"
591 }
592
593 function make_gdb ()
594 {
595 run_configure_if_required
596
597 if command_exists gdb; then
598
599 push_TESTS_ENVIRONMENT
600
601 # Set ENV GDB_COMMAND
602 if [[ -z "$GDB_COMMAND" ]]; then
603 setup_gdb_command
604 fi
605
606 # If we don't have a configure, then most likely we will be missing libtool
607 assert_file 'configure'
608 if [[ -f 'libtool' ]]; then
609 TESTS_ENVIRONMENT="./libtool --mode=execute $GDB_COMMAND"
610 else
611 TESTS_ENVIRONMENT="$GDB_COMMAND"
612 fi
613
614 make_target check
615
616 if [ -f 'gdb.txt' ]; then
617 rm 'gdb.txt'
618 fi
619
620 pop_TESTS_ENVIRONMENT
621
622 if [ -f '.gdb_history' ]; then
623 rm '.gdb_history'
624 fi
625 else
626 echo 'gdb was not present'
627 return 1
628 fi
629 }
630
631 # $1 target to compile
632 # $2 to die, or not to die, based on contents
633 function make_target ()
634 {
635 if [[ -z "$1" ]]; then
636 die "Programmer error, no target provided for make"
637 fi
638
639 if [ ! -f 'Makefile' ]; then
640 die "Programmer error, make was called before configure"
641 run_configure
642 fi
643
644 if test -n "$TESTS_ENVIRONMENT" -a $VERBOSE; then
645 echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
646 fi
647
648 if [[ -z "$MAKE" ]]; then
649 die "MAKE was not set"
650 fi
651
652 if [[ -n "$2" ]]; then
653 run $MAKE $1 || return 1
654 else
655 run $MAKE $1 || die "Cannot execute $MAKE $1"
656 fi
657 }
658
659 function make_distcheck ()
660 {
661 make_target 'distcheck'
662 }
663
664 function make_rpm ()
665 {
666 run_configure_if_required
667 make_target 'rpm'
668 }
669
670 function make_maintainer_clean ()
671 {
672 run_configure_if_required
673 make_target 'maintainer-clean' 'no_error'
674 }
675
676 function make_check ()
677 {
678 make_target 'check'
679 }
680
681 function make_jenkins_default ()
682 {
683 run_configure
684 make_target 'all'
685 }
686
687 function make_default ()
688 {
689 run_configure_if_required
690 make_target 'all'
691 }
692
693 function run_configure_if_required ()
694 {
695 run_autoreconf_if_required
696
697 if [ ! -f 'Makefile' ]; then
698 run_configure
699 fi
700
701 assert_file 'Makefile' 'configure did not produce a Makefile'
702 }
703
704 function run_autoreconf_if_required ()
705 {
706 if [ ! -x 'configure' ]; then
707 run_autoreconf
708 fi
709
710 assert_exec_file 'configure'
711 }
712
713 function run_autoreconf ()
714 {
715 if [[ -z "$AUTORECONF" ]]; then
716 die "Programmer error, tried to call run_autoreconf () but AUTORECONF was not set"
717 fi
718
719 run $AUTORECONF || die "Cannot execute $AUTORECONF"
720
721 eval 'bash -n configure' || die "autoreconf generated a malformed configure"
722 }
723
724 function run ()
725 {
726 if $VERBOSE; then
727 echo "\`$@' $ARGS"
728 fi
729
730 eval $@ $ARGS
731 }
732
733 parse_command_line_options ()
734 {
735 local SHORTOPTS=':apcmt:dvh'
736
737 nassert MAKE_TARGET
738
739 while getopts "$SHORTOPTS" opt; do
740 case $opt in
741 a) #--autoreconf
742 AUTORECONF_OPTION=true
743 MAKE_TARGET='autoreconf'
744 ;;
745 p) #--print-env
746 PRINT_SETUP_OPTION=true
747 ;;
748 c) # --configure
749 CONFIGURE_OPTION=true
750 MAKE_TARGET='configure'
751 ;;
752 m) # maintainer-clean
753 CLEAN_OPTION=true
754 MAKE_TARGET='clean_op'
755 ;;
756 t) # target
757 TARGET_OPTION=true
758 TARGET_OPTION_ARG="$OPTARG"
759 MAKE_TARGET="$OPTARG"
760 ;;
761 d) # debug
762 DEBUG_OPTION=true
763 enable_debug
764 ;;
765 h) # help
766 echo "bootstrap.sh [options] optional_target ..."
767 exit
768 ;;
769 v) # verbose
770 VERBOSE_OPTION=true
771 VERBOSE=true
772 ;;
773 :)
774 echo "Option -$OPTARG requires an argument." >&2
775 exit 1
776 ;;
777 *)
778 echo "$0: error - unrecognized option $1" 1>&2
779 exit 1
780 ;;
781 esac
782 done
783
784 shift $((OPTIND-1))
785
786 if [ -n "$1" ]; then
787 MAKE_TARGET="$@"
788 fi
789 }
790
791 determine_vcs ()
792 {
793 if [[ -d '.git' ]]; then
794 VCS_CHECKOUT=git
795 elif [[ -d '.bzr' ]]; then
796 VCS_CHECKOUT=bzr
797 elif [[ -d '.svn' ]]; then
798 VCS_CHECKOUT=svn
799 elif [[ -d '.hg' ]]; then
800 VCS_CHECKOUT=hg
801 fi
802
803 if [[ -n "$VCS_CHECKOUT" ]]; then
804 VERBOSE=true
805 fi
806 }
807
808 autoreconf_setup ()
809 {
810 # Set ENV MAKE in order to override "make"
811 if [[ -z "$MAKE" ]]; then
812 if command_exists gmake; then
813 MAKE=`type -p gmake`
814 else
815 if command_exists make; then
816 MAKE=`type -p make`
817 fi
818 fi
819
820 if $DEBUG; then
821 MAKE="$MAKE --warn-undefined-variables"
822 fi
823 fi
824
825 if [[ -z "$GNU_BUILD_FLAGS" ]]; then
826 GNU_BUILD_FLAGS="--install --force"
827 fi
828
829 if $VERBOSE; then
830 GNU_BUILD_FLAGS="$GNU_BUILD_FLAGS --verbose"
831 fi
832
833 if [[ -z "$WARNINGS" ]]; then
834 if [[ -n "$VCS_CHECKOUT" ]]; then
835 WARNINGS="all,error"
836 else
837 WARNINGS="all"
838 fi
839 fi
840
841 if [[ -z "$LIBTOOLIZE" ]]; then
842 # If we are using OSX, we first check to see glibtoolize is available
843 if [[ "$VENDOR_DISTRIBUTION" == "darwin" ]]; then
844 LIBTOOLIZE=`type -p glibtoolize`
845
846 if [[ -z "$LIBTOOLIZE" ]]; then
847 echo "Couldn't find glibtoolize, it is required on OSX"
848 fi
849 fi
850 fi
851
852 # Test the ENV AUTOMAKE if it exists
853 if [[ -n "$AUTOMAKE" ]]; then
854 run $AUTOMAKE '--help' &> /dev/null || die "Failed to run AUTOMAKE:$AUTOMAKE"
855 fi
856
857 # Test the ENV AUTOCONF if it exists
858 if [[ -n "$AUTOCONF" ]]; then
859 run $AUTOCONF '--help' &> /dev/null || die "Failed to run AUTOCONF:$AUTOCONF"
860 fi
861
862 # Test the ENV AUTOHEADER if it exists
863 if [[ -n "$AUTOHEADER" ]]; then
864 run $AUTOHEADER '--help' &> /dev/null || die "Failed to run AUTOHEADER:$AUTOHEADER"
865 fi
866
867 # Test the ENV AUTOM4TE if it exists
868 if [[ -n "$AUTOM4TE" ]]; then
869 run $AUTOM4TE '--help' &> /dev/null || die "Failed to run AUTOM4TE:$AUTOM4TE"
870 fi
871
872 if [[ -z "$AUTORECONF" ]]; then
873 AUTORECONF=`type -p autoreconf`
874
875 if [[ -z "$AUTORECONF" ]]; then
876 die "Couldn't find autoreconf"
877 fi
878
879 if [[ -n "$GNU_BUILD_FLAGS" ]]; then
880 AUTORECONF="$AUTORECONF $GNU_BUILD_FLAGS"
881 fi
882 fi
883
884 run $AUTORECONF '--help' &> /dev/null || die "Failed to run AUTORECONF:$AUTORECONF"
885 }
886
887 print_setup ()
888 {
889 saved_debug_status=$DEBUG
890 if $DEBUG; then
891 disable_debug
892 fi
893
894 echo '----------------------------------------------'
895 echo 'BOOTSTRAP ENV'
896 echo "AUTORECONF=$AUTORECONF"
897 echo "HOST_OS=$HOST_OS"
898
899 echo "getopt()"
900 if $AUTORECONF_OPTION; then
901 echo "--autoreconf"
902 fi
903
904 if $CLEAN_OPTION; then
905 echo "--clean"
906 fi
907
908 if $CONFIGURE_OPTION; then
909 echo "--configure"
910 fi
911
912 if $DEBUG_OPTION; then
913 echo "--debug"
914 fi
915
916 if $PRINT_SETUP_OPTION; then
917 echo "--print-env"
918 fi
919
920 if $TARGET_OPTION; then
921 echo "--target=$TARGET_OPTION_ARG"
922 fi
923
924 if $VERBOSE_OPTION; then
925 echo "--verbose"
926 fi
927
928 if [[ -n "$MAKE" ]]; then
929 echo "MAKE=$MAKE"
930 fi
931
932 if [[ -n "$MAKE_TARGET" ]]; then
933 echo "MAKE_TARGET=$MAKE_TARGET"
934 fi
935
936 if [[ -n "$PREFIX" ]]; then
937 echo "PREFIX=$PREFIX"
938 fi
939
940 if [[ -n "$TESTS_ENVIRONMENT" ]]; then
941 echo "TESTS_ENVIRONMENT=$TESTS_ENVIRONMENT"
942 fi
943
944 if [[ -n "$VCS_CHECKOUT" ]]; then
945 echo "VCS_CHECKOUT=$VCS_CHECKOUT"
946 fi
947
948 if $VERBOSE; then
949 echo "VERBOSE=true"
950 fi
951
952 if $DEBUG; then
953 echo "DEBUG=true"
954 fi
955
956 if [[ -n "$WARNINGS" ]]; then
957 echo "WARNINGS=$WARNINGS"
958 fi
959 echo '----------------------------------------------'
960
961 if $saved_debug_status; then
962 enable_debug
963 fi
964 }
965
966 make_clean_option ()
967 {
968 run_configure_if_required
969
970 make_maintainer_clean
971
972 if [[ "$VCS_CHECKOUT" == 'git' ]]; then
973 run "$VCS_CHECKOUT" status --ignored
974 elif [[ -n "$VCS_CHECKOUT" ]]; then
975 run "$VCS_CHECKOUT" status
976 fi
977 }
978
979 make_for_autoreconf ()
980 {
981 if [ -f 'Makefile' ]; then
982 make_maintainer_clean
983 fi
984
985 run_autoreconf
986
987 assert_no_file 'Makefile'
988 }
989
990 check_make_target()
991 {
992 case $1 in
993 'self')
994 ;;
995 'gdb')
996 ;;
997 'clean_op')
998 ;;
999 'autoreconf')
1000 ;;
1001 'install-system')
1002 ;;
1003 'configure')
1004 ;;
1005 'distcheck')
1006 ;;
1007 'check')
1008 ;;
1009 'snapshot')
1010 ;;
1011 'valgrind')
1012 ;;
1013 'jenkins')
1014 ;;
1015 'distclean')
1016 ;;
1017 'maintainer-clean')
1018 ;;
1019 'install')
1020 ;;
1021 'all')
1022 ;;
1023 'test-*')
1024 ;;
1025 'valgrind-*')
1026 ;;
1027 'gdb-*')
1028 ;;
1029 'dist')
1030 ;;
1031 *)
1032 die "Unknown MAKE_TARGET option: $1"
1033 ;;
1034 esac
1035 }
1036
1037 function bootstrap ()
1038 {
1039 determine_target_platform
1040
1041 determine_vcs
1042
1043 # Set up whatever we need to do to use autoreconf later
1044 autoreconf_setup
1045
1046 if [ -z "$MAKE_TARGET" ]; then
1047 MAKE_TARGET="make_default"
1048 fi
1049
1050 if $PRINT_SETUP_OPTION -o $DEBUG; then
1051 echo
1052 print_setup
1053 echo
1054
1055 # Exit if all we were looking for were the currently used options
1056 if $PRINT_SETUP_OPTION; then
1057 exit
1058 fi
1059 fi
1060
1061 # Use OLD_TESTS_ENVIRONMENT for tracking the state of the variable
1062 local OLD_TESTS_ENVIRONMENT=
1063
1064 # Set ENV PREFIX in order to set --prefix for ./configure
1065 if [[ -n "$PREFIX" ]]; then
1066 push_PREFIX_ARG $PREFIX
1067 fi
1068
1069 # We should always have a target by this point
1070 assert MAKE_TARGET
1071
1072 local MAKE_TARGET_ARRAY=($MAKE_TARGET)
1073
1074 for target in "${MAKE_TARGET_ARRAY[@]}"
1075 do
1076 # If we are running inside of Jenkins, we want to only run some of the possible tests
1077 if $jenkins_build_environment; then
1078 check_make_target $target
1079 fi
1080
1081 case $target in
1082 'self')
1083 self_test
1084 ;;
1085 'gdb')
1086 make_gdb
1087 ;;
1088 'clean_op')
1089 make_clean_option
1090 ;;
1091 'autoreconf')
1092 make_for_autoreconf
1093 ;;
1094 'install-system')
1095 make_install_system
1096 ;;
1097 'configure')
1098 run_configure
1099 ;;
1100 'default')
1101 make
1102 run_configure
1103 ;;
1104 'snapshot')
1105 make_for_snapshot
1106 ;;
1107 'rpm')
1108 make_rpm
1109 ;;
1110 'valgrind')
1111 make_valgrind
1112 ;;
1113 'jenkins')
1114 make_for_continuus_integration
1115 ;;
1116 *)
1117 run_configure_if_required
1118 make_target "$target"
1119 ;;
1120 esac
1121 done
1122 }
1123
1124 main ()
1125 {
1126 # Variables we export
1127 declare -x VCS_CHECKOUT=
1128
1129 # Variables we control globally
1130 local MAKE_TARGET=
1131
1132 # Options for getopt
1133 local AUTORECONF_OPTION=false
1134 local CLEAN_OPTION=false
1135 local CONFIGURE_OPTION=false
1136 local DEBUG_OPTION=false
1137 local PRINT_SETUP_OPTION=false
1138 local TARGET_OPTION=false
1139 local TARGET_OPTION_ARG=
1140 local VERBOSE_OPTION=false
1141
1142 # If we call autoreconf on the platform or not
1143 local AUTORECONF_REBUILD_HOST=false
1144 local AUTORECONF_REBUILD=false
1145
1146 local -r top_srcdir=`pwd`
1147
1148 # Variables for determine_target_platform () and rebuild_host_os ()
1149 # UNAME_MACHINE_ARCH= uname -m
1150 # VENDOR= apple, redhat, centos, canonical
1151 # VENDOR_RELEASE=
1152 # RHEL{rhel,Tikanga,Santiago}
1153 # Ubuntu{ubuntu,Lucid,Maverick,Natty,Oneiric,Precise,Quantal}
1154 # Fedora{fedora,Verne,Beefy}
1155 # OSX{osx,lion,snow,mountain}
1156 # VENDOR_DISTRIBUTION= darwin,fedora,rhel,ubuntu
1157 # UNAME_KERNEL= Linux, Darwin,...
1158 # UNAME_KERNEL_RELEASE= Linux, Darwin,...
1159 local UNAME_MACHINE_ARCH=unknown
1160 local VENDOR=unknown
1161 local VENDOR_RELEASE=unknown
1162 local VENDOR_DISTRIBUTION=unknown
1163 local UNAME_KERNEL=unknown
1164 local UNAME_KERNEL_RELEASE=unknown
1165 local HOST_OS=
1166
1167 rebuild_host_os no_output
1168
1169 parse_command_line_options $@
1170
1171 # If we are running under Jenkins we predetermine what tests we will run against
1172 # This MAKE_TARGET can be overridden by parse_command_line_options based MAKE_TARGET changes.
1173 # We don't want Jenkins overriding other variables, so we NULL them.
1174 if [ -z "$MAKE_TARGET" -a $jenkins_build_environment ]; then
1175 MAKE_TARGET='jenkins'
1176 fi
1177
1178 bootstrap
1179
1180 jobs -l
1181 wait
1182
1183 exit 0
1184 }
1185
1186 enable_debug ()
1187 {
1188 if ! $DEBUG; then
1189 local caller_loc=`caller`
1190 if [ -n $1 ]; then
1191 echo "$caller_loc Enabling debug: $1"
1192 else
1193 echo "$caller_loc Enabling debug"
1194 fi
1195 set -x
1196 DEBUG=true
1197 fi
1198 }
1199
1200 disable_debug ()
1201 {
1202 set +x
1203 DEBUG=true
1204 }
1205
1206 # Script begins here
1207
1208 env_debug_enabled=false
1209 if [[ -n "$JENKINS_HOME" ]]; then
1210 declare -r jenkins_build_environment=true
1211 else
1212 declare -r jenkins_build_environment=false
1213 fi
1214
1215 export AUTOCONF
1216 export AUTOHEADER
1217 export AUTOM4TE
1218 export AUTOMAKE
1219 export AUTORECONF
1220 export DEBUG
1221 export GNU_BUILD_FLAGS
1222 export MAKE
1223 export TESTS_ENVIRONMENT
1224 export VERBOSE
1225 export WARNINGS
1226
1227 case $OSTYPE in
1228 darwin*)
1229 export MallocGuardEdges
1230 export MallocErrorAbort
1231 export MallocScribble
1232 ;;
1233 esac
1234
1235 # We check for DEBUG twice, once before we source the config file, and once afterward
1236 env_debug_enabled=false
1237 if [[ -n "$DEBUG" ]]; then
1238 env_debug_enabled=true
1239 enable_debug
1240 print_setup
1241 fi
1242
1243 # Variables which only can be set by .bootstrap
1244 BOOTSTRAP_SNAPSHOT=false
1245 BOOTSTRAP_SNAPSHOT_CHECK=
1246
1247 if [ -f '.bootstrap' ]; then
1248 source '.bootstrap'
1249 fi
1250
1251 if $env_debug_enabled; then
1252 enable_debug
1253 else
1254 if [[ -n "$DEBUG" ]]; then
1255 enable_debug "Enabling DEBUG from '.bootstrap'"
1256 print_setup
1257 fi
1258 fi
1259
1260 # We do this in order to protect the case where DEBUG
1261 if ! $env_debug_enabled; then
1262 DEBUG=false
1263 fi
1264
1265 main $@